

#pragma once

#include "ComSurrogateScanning_i.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

using namespace ATL;




class ATL_NO_VTABLE CObjectFactory :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CObjectFactory, &CLSID_ObjectFactory>,
	public ISupportErrorInfo,
	public IDispatchImpl<IObjectFactory, &IID_IObjectFactory, &LIBID_ComSurrogateScanningLib,  1,  0>
{
public:

	CObjectFactory();
	virtual ~CObjectFactory();

	DECLARE_REGISTRY_RESOURCEID(110)


	BEGIN_COM_MAP(CObjectFactory)
		COM_INTERFACE_ENTRY(IObjectFactory)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(ISupportErrorInfo)
	END_COM_MAP()

	
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID) override;

	DECLARE_CLASSFACTORY_SINGLETON(CObjectFactory)
	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:
	
	STDMETHOD(CreateScanner)(BSTR ScannerModel, BSTR ConfigFilename, IIsisScanner** ppResult) override;
	STDMETHOD(CreateSystemInfo)(ISystemInfo** ppResult) override;
	STDMETHOD(CreateScannerByDriverDescription)(BSTR DriverDescription, BSTR ConfigFilename, IIsisScanner** ppResult) override;
	STDMETHOD(CreateScannerByDriverName)(BSTR DriverName, BSTR ConfigFilename, IIsisScanner** ppResult) override;

private:
	ISystemInfo* m_pSystemInfo;

};

OBJECT_ENTRY_AUTO(__uuidof(ObjectFactory), CObjectFactory)

